import unittest
import logging
import thespian.test.helpers
from thespian.actors import *
from thespian.test import ActorSystemTestCase

class Clooney(Actor):
    def receiveMessage(self, msg, sender):
        logger = logging.getLogger('Thespian.Actor')
        logger.setLevel(logging.DEBUG)
        logger.info('Clooney got message "%s" from %s'%(str(msg), str(sender)))
        self.send(sender, 'Greetings.')

class Jolie(Actor): pass

class Hamlet(Actor):
    def receiveMessage(self, msg, sender):
        if msg == 'Alas, poor Yorick!':
            self.send(self.myAddress, (sender, 'To be or not to be?'))
        if isinstance(msg, tuple) and msg[1] == 'To be or not to be?':
            self.send(msg[0], 'That is the question.')


class TestASimpleSystem(ActorSystemTestCase):

    def testSimpleActor(self):
        clooney = ActorSystem().createActor(Clooney)

    def testSimpleActorTell(self):
        clooney = ActorSystem().createActor(Clooney)
        ActorSystem().tell(clooney, 'hello')

    def testSimpleActorAsk(self):
        clooney = ActorSystem().createActor(Clooney)
        self.assertEqual(ActorSystem().ask(clooney, 'hello', 0.5), 'Greetings.')

    def testSendTupleToSelf(self):
        hamlet = ActorSystem().createActor(Hamlet)
        self.assertEqual(ActorSystem().ask(hamlet, 'Alas, poor Yorick!', 1),
                         'That is the question.')

#until multiprocess system works on Windows
import os
if os.name!='nt':
    class TestMultiProcessSystem(TestASimpleSystem):

        def setUp(self):
            self.setSystemBase('multiprocessSystemBase')
